/*****************************
* Source : XbZLib.prg
* System : <unkown>
* Author : Phil Ide
* Created: 08/08/2003
*
* Purpose:
* ----------------------------
* History:
* ----------------------------
*    08/08/2003 17:52 PPI - Created
*****************************/

#include "Common.ch"
#include "dll.ch"
#include "piCommon.ch"
#include "XbZLib.ch"
#include "directry.ch"
#include "fileio.ch"

Function XbZLibVer()
   return _XBZLIB_VER_MAJOR + Mantissa(_XBZLIB_VER_MINOR)

STATIC Function Mantissa(n)
   local c := LTrim(Str(Int(n)))

   if At('.',c) > 0
      c := Left( c, At('.', c)-1 )
   endif
   Return Val('0.'+c)

Function XbZLibZVer()
   return zversion()

Function xbzCompress( cData, nError )
   local nLen0 := Len(cdata)
   local cDest := Space( (nLen0*1.01)+12 )
   local nLen1 := Len(cDest)

   nError := zCompress(@cDest,@nLen1,@cData,nLen0)
   return left(cDest,nLen1)

Function xbzUnCompress( cData, nSize )
   local nLen0 := Len(cdata)
   local cDest := Space( nSize )

   nSize := zUnCompress(@cDest,@nSize,@cData,nLen0)
   return cDest

Function xbzCompress2( cData, nError, nLevel )
   local nLen0 := Len(cdata)
   local cDest := Space( (nLen0*1.01)+12 )
   local nLen1 := Len(cDest)

   default nLevel to -1

   if (nLevel OUTSIDE -1, 9)
      nLevel := -1
   endif

   nError := zCompress2(@cDest,@nLen1,@cData,nLen0,nLevel)
   return left(cDest,nLen1)

Function xbzGzOpen( cFile, cMode )// "rb" or "wb"
   return zgzOpen( cFile, cMode )

Function xbzGzDOpen( nFHandle, cMode )// "rb" or "wb"
   return zgzDOpen( nFHandle, cMode )

Function xbzGzSetParams( gzFile, nLevel, nStrategy )
   return zgzsetparams( gzFile, nLevel, nStrategy )

Function xbzGzRead( gzFile, cBuff, nLen )
   return zGzRead( gzFile, @cBuff, nLen )

Function xbzGzWrite( gzFile, cBuff, nLen )
   return zGzWrite( gzFile, @cBuff, nLen )

Function xbzGzPutS( gzFile, cString )
   return zGzPutS( gzFile, cString )

Function xbzGzGetS( gzFile, cString, nLen )
   return zGzGetS( gzFile, @cString, nLen )

Function xbzGzPutC( gzFile, cChar )
   return zGzPutS( gzFile, cChar )

Function xbzGzGetC( gzFile )
   return zGzGetC( gzFile )

Function xbzGzFlush( gzFile, nFlush )
   default nFlush to 0
   return zGzFlush( gzFile, nFlush )

Function xbzgzSeek( gzFile, nOffset, Whence )
   return zGzSeek( gzFile, nOffset, Whence )

Function xbzgzReWind( gzFile )
   return zGzReWind( gzFile )

Function xbzgzTell( gzFile )
   return zGzTell( gzFile )

Function xbzgzEof( gzFile )
   return zGzEof( gzFile )

Function xbzgzClose( gzFile )
   return zGzClose( gzFile )

Function xbzgzError( gzFile, nErr )
   return zGzError( gzFile, @nErr )

Function xbzCrc32(crc, buff, n)
   return zzgcrc32(crc, buff, n)



// 28+16=(44)+14=(58)+MAX_PATH
Function XbZfileTime(cFile, cAttr)
   local w32FF := Replicate(Chr(0),58)+Space(MAX_PATH)
   local FTimeStruct := Space(8)
   local FTimeStruct2 := Space(8)
   local fatDate := Space(2)
   local fatTime := Space(2)

   local hFind

   hFind := FindFirstFile( cFile, @w32FF )
   FTimeStruct := SubStr( w32FF, 21, 8 )
   FileTimeToLocalFileTime(FTimeStruct,@FTimeStruct2)
   FileTimeToDosDateTime( FTimeStruct2, @fatDate, @fatTime )
   FindClose( hFind )

   cAttr := left(w32FF,4)
   return fatTime+fatDate

Function XbFileTimeDate2DOSTimeDate( aF, cAttr )
   local nSecs := Val(Right( aF[1][F_WRITE_TIME], 2 ))
   local nMins := Val(SubStr( aF[1][F_WRITE_TIME], 4, 2 ))
   local nHrs  := Val(Left( aF[1][F_WRITE_TIME], 2 ))

   local nDay   := Day( aF[1][F_WRITE_DATE] )
   local nMonth := Month( aF[1][F_WRITE_DATE] )
   local nYear  := Year( aF[1][F_WRITE_DATE] )

   local cTime := 0
   local cDate := 0

   nSecs := Int(nSecs/2)

   cTime[ 1] := nSecs[1]
   cTime[ 2] := nSecs[2]
   cTime[ 3] := nSecs[3]
   cTime[ 4] := nSecs[4]
   cTime[ 5] := nSecs[5]

   cTime[ 6] := nMins[1]
   cTime[ 7] := nMins[2]
   cTime[ 8] := nMins[3]
   cTime[ 9] := nMins[4]
   cTime[10] := nMins[5]
   cTime[11] := nMins[5]

   cTime[12] := nHrs[1]
   cTime[13] := nHrs[2]
   cTime[14] := nHrs[3]
   cTime[15] := nHrs[4]
   cTime[16] := nHrs[5]

   cTime := Left(U2Bin(cTime),2)

   nYear -= 1980

   cDate := nYear
   cDate := (cDate << 4)
   cDate += nMonth
   cDate := (cDate << 4)
   cDate += nDay

   cDate := Left(L2Bin(cDate),2)

   cAttr := 0
   cAttr[1] := 'R' $ aF[1][F_ATTR]
   cAttr[2] := 'H' $ aF[1][F_ATTR]
   cAttr[3] := 'S' $ aF[1][F_ATTR]
   cAttr[4] := 'V' $ aF[1][F_ATTR]
   cAttr[5] := 'D' $ aF[1][F_ATTR]
   cAttr[6] := 'A' $ aF[1][F_ATTR]

   cAttr := I2Bin(cAttr)

   return cTime+cDate


Function Attrib2Xbase(n)
   local cRet

   n := Bin2L(n)

   cRet := iif( n[1], 'R', '.' )
   cRet := iif( n[2], 'H', '.' )
   cRet := iif( n[3], 'S', '.' )
   cRet := iif( n[4], 'V', '.' )
   cRet := iif( n[5], 'D', '.' )
   cRet := iif( n[6], 'A', '.' )
   return cRet




Function XbzDOSFT2XbFT( fatTime, fatDate )
   local nTime := Bin2U(fatTime)
   local nDate := Bin2U(fatDate)

   local nSecs := 0
   local nMins := 0
   local nHrs  := 0

   local nDay   := 0
   local nMonth := 0
   local nYear  := 0

   local cTime
   local dDate

   nSecs[1] := nTime[1]
   nSecs[2] := nTime[2]
   nSecs[3] := nTime[3]
   nSecs[4] := nTime[4]
   nSecs[5] := nTime[5]
   nSecs *= 2

   nMins[1] := nTime[6]
   nMins[2] := nTime[7]
   nMins[3] := nTime[8]
   nMins[4] := nTime[9]
   nMins[5] := nTime[10]
   nMins[6] := nTime[11]

   nHrs[1] := nTime[12]
   nHrs[2] := nTime[13]
   nHrs[3] := nTime[14]
   nHrs[4] := nTime[15]
   nHrs[5] := nTime[16]

   nDay[1] := nDate[1]
   nDay[2] := nDate[2]
   nDay[3] := nDate[3]
   nDay[4] := nDate[4]
   nDay[5] := nDate[5]

   nMonth[1] := nDate[6]
   nMonth[2] := nDate[7]
   nMonth[3] := nDate[8]
   nMonth[4] := nDate[9]

   nYear[1] := nDate[10]
   nYear[2] := nDate[11]
   nYear[3] := nDate[12]
   nYear[4] := nDate[13]
   nYear[5] := nDate[14]
   nYear[6] := nDate[15]
   nYear[7] := nDate[16]

   nYear += 1980

   cTime := StrZero( nHrs, 2 ) + ':' + StrZero( nMins, 2 ) + ':' + StrZero( nSecs, 2 )
//   dDate := stod( StrZero(nYear,4)+StrZero(nMonth,2)+StrZero(nDay,2) )

   dDate := ctod( StrZero(nYear,4)+'/'+StrZero(nMonth,2)+'/'+StrZero(nDay,2) )
   return {cTime, dDate}

DLLFUNCTION zzipOpen( cP, n) ALIAS zipOpen USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zzipClose( z, c ) ALIAS zipClose USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zzipOpenNewFileInZip(z,cFile,zi,a,b,c,d,e,f,g) ALIAS zipOpenNewFileInZip USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zzipWriteFileInZip(z,c,n) ALIAS zipWriteInFileInZip USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zzipCloseFileInZip( z ) ALIAS zipCloseFileInZip USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgetFileCrc( c, b, n, @crc ) ALIAS getfilecrc USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zversion() ALIAS zlibVersion USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zcompress(@cOut,@nOut,@cIn,nIn) ALIAS compress USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zuncompress(@cOut,@nOut,@cIn,nIn) ALIAS uncompress USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zcompress2(@cOut,@nOut,@cIn,nIn, nLevel) ALIAS compress2 USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzopen(cFile,cMode) ALIAS gzopen USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzdopen(nFile,cMode) ALIAS gzdopen USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzsetparams( gzFile, nLevel, nStrategy ) ALIAS gzsetparams USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzread( gzFile, @cBuff, nLen ) ALIAS gzread USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzwrite( gzFile, @cBuff, nLen ) ALIAS gzwrite USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzputs( gzFile, cString ) ALIAS gzputs USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzgets( gzFile, @cBuff, nLen ) ALIAS gzgets USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzputc( gzFile, c ) ALIAS gzputc USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzgetc( gzFile ) ALIAS gzgetc USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzflush( gzFile, n ) ALIAS gzflush USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzseek( gzFile, n, nW ) ALIAS gzseek USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzrewind( gzFile ) ALIAS gzrewind USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgztell( gzFile ) ALIAS gztell USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzeof( gzFile ) ALIAS gzeof USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzclose( gzFile ) ALIAS gzclose USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zgzerror( gzFile, @n ) ALIAS gzerror USING CALL_TYPE FROM ZLIB_DLL
DLLFUNCTION zzgcrc32(crc, buff, n) ALIAS crc32 USING CALL_TYPE FROM ZLIB_DLL

DLLFUNCTION FindFirstFile(c,@w) ALIAS FindFirstFileA USING STDCALL FROM Kernel32.dll
DLLFUNCTION FindClose(c) ALIAS FindClose USING STDCALL FROM Kernel32.dll
DLLFUNCTION FileTimeToDosDateTime(f,@fd,@ft) ALIAS FileTimeToDosDateTime USING STDCALL FROM Kernel32.dll
DLLFUNCTION FileTimeToLocalFileTime(f,@fx) ALIAS FileTimeToLocalFileTime USING STDCALL FROM Kernel32.dll

