/*****************************
* Source : XbZlib.prg
* System : <unkown>
* Author : Phil Ide
* Created: 08/08/2003
*
* Purpose:
* ----------------------------
* History:
* ----------------------------
*    08/08/2003 16:53 PPI - Created
*****************************/

#include "Common.ch"
#include "Appevent.ch"
#include "dll.ch"
#include "set.ch"
#include "xbzlib.ch"
#include "directry.ch"

#define CRLF Chr(13)+Chr(10)

proc dbesys();return


Procedure Main( cOpt, cFile1, cFile2, cSubDir )

   default cOpt to "0",;
           cSubDir to 'N'

   cOpt := Val(cOpt)

   do case
      case cOpt == 0
         Help()

      case cOPt == 1
         InMemoryCompress(cFile1)

      case cOpt == 2
         CreateArchive( cFile1, cFile2, cSubDir $ 'Yy' )
   endcase
   return

Function Help()
   //? 'ZLib   v'+zversion()
   ? 'XbZlib v'+LTrim(Str(XbZLibVer()))
   ? 'Usage: XbZLibTest [option] [cFile1] [cFile2]'
   ?
   ? '   Option:'
   ? '       0 - display help'
   ? '       1 - show in-memory compression of file'
   ? '           XbZlibTest 1 <file>'
   ? '             outputs <cFile> to <cFile.cpx>'
   ? '       2 - create .zip archive'
   ? '          XbZlibTest <fileSpec> <archiveName> [Y]'
   ? '             XbZlibTest *.* myArchive Y'
   ? '             (Y = include subdirs)'
   wait
   return 0

Function InMemoryCompress(cFile)
   local c := memoread(cFile)
   local nError := 0
   local cx
   local nH
   local i

   cx := xbzCompress(c, @nError)
   if (i := Rat('.',cFile)) > 0
      if i > Rat('\',cFile)
         cFile := Left(cFile,i-1)
      endif
   endif
   cFile += '.cpx'
   if (nH := FCreate(cFile)) > 0
      FWrite(nH, cx)
      FClose(nH)
   endif
   return 0

Function CreateArchive( cFSpec, cArc, lSubD)
   local oZip
   local aFiles
   local i
   local cBuff := ''
   local cAttrib := iif( lSubD, 'D', '' )

   Set(_SET_DATEFORMAT,'yyyy.mm.dd')

   if lower(Right(cArc,4)) <> '.zip'
      cArc += '.zip'
   endif

   if FExists(cArc)
      FErase(cArc)
   endif
   if !FExists(cArc)
      oZip := xbZlZip():new()
      oZip:open(cArc)
      AddDirToArc( oZip, cFSpec, cAttrib )
      oZip:close('This is an archive comment')

      oZip := xbZlZip():new()
      oZip:open(cArc, ZLZIP_OPEN_READ)
      DisplayList( oZip )
      oZip:close()
   endif
   return 0

Function AddDirToArc( oZip, cFSpec, cAttr, cRoot )
   local aFiles
   local i
   local nCount := 0

   default cRoot to ''

   if !Empty(cRoot)
      cRoot += '\'
   endif

   aFiles := Directory(cRoot+cFSpec, cAttr)

   for i := 1 to Len(aFiles)
      if !(aFiles[i][F_NAME] == '.' .or. aFiles[i][F_NAME] == '..')
         if 'D' $ aFiles[i][F_ATTR]
            nCount += AddDirToArc( oZip, cFSpec, cAttr, cRoot+aFiles[i][F_NAME] )
         else
            oZip:addFile(cRoot+aFiles[i][1],,lower(aFiles[i][F_NAME]))
            nCount++
         endif
      endif
   next
   return nCount


Function DisplayList(oZip)
   local a
   local oDlg := ZipBrowse():new():create()
   local oP := oDlg:drawingArea
   local aSize := oP:currentSize()
   local oBrowse
   local nEvent, mp1, mp2, oXbp
   local aList := oZip:directory()
   local aBrowse := Array(Len(aList))
   local c

   aSize[1] -= 20
   aSize[2] -= 20
   aPos := {10,10}

   oDlg:setTitle(oZip:fileName)

   for i := 1 to len(aList)
      c := GetTimedate( aList[i].fileTime )
      aBrowse[i] := {aList[i].fileName,;
                     aList[i].compSize,;
                     aList[i].UnCompSize,;
                     ZLIB_COMP_TEXT[aList[i].compMethod+1],;
                     Bin2U(aList[i].crc),;
                     dtoc(c[2]),c[1],,,aList[i].comment}
      aBrowse[i][-3] := Attrib2Xbase(aList[i].externalFAttrib)
      aBrowse[i][-2] := Str(100-((aList[i].compSize/aList[i].UnCompSize)*100),6)+'%'

   next
   ASort( aBrowse,,, {|a,b| upper(a[1]) < upper(b[1]) } )

   oBrowse := myArrayBrowse():new( oDlg:drawingArea,,aPos, aSize ):create()
   oBrowse:setArray(aBrowse)
   oBrowse:addColumnBlock(1,25,"File Name" )
   oBrowse:addColumnBlock(2,8,"Compressed Size" )
   oBrowse:addColumnBlock(3,8,"Original Size" )
   oBrowse:addColumnBlock(4,16,"Method" )
   oBrowse:addColumnBlock(5,16,"crc32" )
   oBrowse:addColumnBlock(6,12,"Date" )
   oBrowse:addColumnBlock(7,12,"Time" )
   oBrowse:addColumnBlock(8,12,"Attributes" )
   oBrowse:addColumnBlock(9,12,"Ratio" )
   oBrowse:addColumnBlock(10,20,"File Comment" )



   oBrowse:show()
   SetAppFocus(oBrowse)

   While nEvent <> xbeP_Close
      nEvent := AppEvent(@mp1,@mp2,@oXbp)
      oXbp:handleEvent(nEvent,mp1,mp2)
   Enddo

   a := aList[1].fileName

   return nil

STATIC Function GetTimedate( fTime )
   local aRet
   aRet := XbzDOSFT2XbFT( left(fTime,2), Right(fTime,2) )
   return aRet



Function TestVer()
   msgBox( "XbZLib v"+LTrim(Str(XbZLibVer())), "XbZLib" )
   return 0

Function Compress( cFile )
   local cBuff := BRead(cFile)
   local nLen0 := Len(cBuff)
   local cDest := Space( (nLen0 * 1.01)+12 )
   local nLen1
   local i := 0

   local cHead

   TestVer()

   cDest := xbzCompress( cBuff, @i )

   if i == 0
      i := rat('.',cFile)
      if i == 0
         i := Len(cFile)
      else
         i--
      endif
      cHead := U2Bin(nLen0)
      nLen1 := Len(cDest)
      cDest := cHead+left(cDest,nLen1)
      cFile := Left(cFile,i)+'.zp'
      i := FCreate(cFile)
      FWrite(i, cDest, len(cDest))
      FClose(i)
   endif
   return Nil

Function Uncompress( cIn, cOut )
   local cBuff := BRead(cIn)
   local nLen0 := len(cBuff)
   local cDest
   local nLen1
   local i

   nLen1 := Bin2U(left(cBuff,4))
   cBuff := SubStr(cBuff,5)

   TestVer()
   
   cDest := xbzUnCompress( cBuff, @nLen1 )

   i := nLen1

   if i == 0
      i := FCreate(cOut)
      FWrite(i, cDest, Len(cDest))
      FClose(i)
   endif
   return Nil

// Binary READ file
// like Memoread.
Function BRead(c)
   local nH := FOpen(c)
   local cBuff := ''
   local i

   i := FSeek(nH,0,2)
   FSeek(nH,0,0)
   cBuff := Space(i)
   FRead(nH,@cBuff,i)
   FClose(nH)
   Return cBuff
// --= eof =--
