#ifndef __XBZLIB__
   #define __XBZLIB__
   #define _XBZLIB_VER_MAJOR 0
   #define _XBZLIB_VER_MINOR 6
   
   #define ZLIB_DLL zlib.dll
   #define CALL_TYPE CDECL

   #define ZLIB_SIGNATURE Chr(0x78)+Chr(0x9c)

   // ZIP definitions
   #define ZLZIP_OPEN_CREATE     0
   #define ZLZIP_OPEN_APPEND     1
   #define ZLZIP_OPEN_READ       2

   #define ZLZIP_COMP_STORE      0
   #define ZLZIP_COMP_SHRUNK     1
   #define ZLZIP_COMP_REDUCED1   2
   #define ZLZIP_COMP_REDUCED2   3
   #define ZLZIP_COMP_REDUCED3   4
   #define ZLZIP_COMP_REDUCED4   5
   #define ZLZIP_COMP_IMPLODED   6
   #define ZLZIP_COMP_TOKENIZED  7
   #define ZLZIP_COMP_DEFLATED   8
   #define ZLZIP_COMP_DEFLATE64  9
   #define ZLZIP_COMP_PKDCL      10

   #define ZLIB_COMP_TEXT {"Store",;
                           "Shrunk",;
                           "Reduced1",;
                           "Reduced2",;
                           "Reduced3",;
                           "Reduced4",;
                           "Imploded",;
                           "Tokenized",;
                           "Deflated",;
                           "Deflate64",;
                           "PKDCL"}

   #define APPEND_STATUS_CREATE        (0)
   #define APPEND_STATUS_CREATEAFTER   (1)
   #define APPEND_STATUS_ADDINZIP      (2)

   #define Z_NO_COMPRESSION         0
   #define Z_BEST_SPEED             1
   #define Z_BEST_COMPRESSION       9
   #define Z_DEFAULT_COMPRESSION  (-1)

   #define Z_DEFLATED   8

   #define MAX_WBITS 15

   #define Z_FILTERED            1
   #define Z_HUFFMAN_ONLY        2
   #define Z_RLE                 3
   #define Z_DEFAULT_STRATEGY    0

   #TRANSLATE (<a> \<\< <b>) => ((<a>)*2^(<b>))

   #pragma Map(filetime,"_XBZLFILETIME")
   #pragma Map(crc32,"_XBZLCRC32")
   
   #define MAX_PATH 260

   #define LOCAL_FILE_RECORD           U2Bin(0x04034b50)
   #define END_OF_CENTRAL_DIR_RECORD   U2Bin(0x06054b50)
   #define CENTRAL_DIR_SIGNATURE       U2Bin(0x02014b50)


   // local file record structure
   #xtranslate .signature      => :signature
   #xtranslate .verToExtract   => :verToExtract
   #xtranslate .gpFlag         => :gpFlag      
   #xtranslate .compMethod     => :compMethod  
   #xtranslate .fileTime       => :fileTime    
   #xtranslate .crc            => :crc         
   #xtranslate .compSize       => :compSize    
   #xtranslate .unCompSize     => :unCompSize  
   #xtranslate .fNameLen       => :fNameLen    
   #xtranslate .extraFldLen    => :extraFldLen 
   #xtranslate .fileName        => :fileName
   #xtranslate .extraFld        => :extraFld       

   #xtranslate .verMadeBy       => :verMadeBy
   #xtranslate .commentLen      => :commentLen
   #xtranslate .diskNumStart    => :diskNumStart   
   #xtranslate .internalFAttrib => :internalFAttrib
   #xtranslate .externalFAttrib => :externalFAttrib
   #xtranslate .offset          => :offset         
   #xtranslate .comment         => :comment

   #xtranslate .diskNumber      => :diskNumber
   #xtranslate .diskNumWStartCD => :diskNumWStartCD
   #xtranslate .entriesThisDisk => :entriesThisDisk
   #xtranslate .entries         => :entries        
   #xtranslate .sizeOfCD        => :sizeOfCD       
   #xtranslate .startOfCD       => :startOfCD

   #xtranslate .cargo           => :cargo
   #xtranslate .gComment        => :gComment

   #xtranslate OClone(<o>) => Bin2Var( Var2Bin( <o> ) )

   #define PNG_SIGNATURE Chr(137)+Chr(80)+Chr(78)+Chr(71)+Chr(13)+Chr(10)+Chr(26)+Chr(10)
#endif

